#!/bin/sh

infile="$1"
shift
srcdir="$1"
shift

if test "$infile" = "" -o "$srcdir" = ""; then
        echo "please supply infile and srcdir"
        exit 1
fi

module_ptrs="    NULL\\\n"
includes=""

for plugin in ${1+"$@"} ; do
		module_ptrs="    plugin_${plugin}_ptr,\\\n$module_ptrs"
		hdrfile="plugins/${plugin}/${plugin}.h"
		if test -f "$srcdir/$hdrfile" ; then
		  includes="#include \"$hdrfile\"\\\n$includes"
		fi
done

cat $infile | \
  sed \
    -e "s'@PLUGIN_INCLUDES@'$includes'" \
		-e "s'@PLUGIN_PTRS@'$module_ptrs'" \
		-e 's/\\n/\
/g'
