#include "squaroid.h"


ulong lowball_onload(Plugin *lowball)
{
	printf("lowball plugin loaded.\nCopyright (c) 2000 Lukas Schroeder\n");
	return PLUGIN_SUCCESS;
}

ulong lowball_onunload()
{
	printf("lowball plugin unloaded\n");
	return PLUGIN_SUCCESS;
}

ulong lowball_ongamestart(Game *game)
{
	game_chatmessage(game, STARTOFF " This is a \0032Lowball\003 Game.\n");
	game_chatmessage(game, STARTOFF " The player who makes 150 points with\n"
									 STARTOFF " a margin of 15+ points \0035loses\003\n");
	return PLUGIN_SUCCESS;
}

ulong lowball_ongameover(Game *game)
{
	struct gameover_captions captions;
	
	/* dont handle observed games */
	if (game->mode == GAME_OBSERVE)
		return -1;                  /* -1 so the main code is executed */
	
	/* dont handle non-networked games */
	if ( !(game->mode == GAME_NETWORK || game->mode == GAME_TOURNAMENT) )
		return -1;
	
	/* switch players, so the get_captions function is tricked ;) */
	if (game->who_am_i == PLAYER2)
		game->who_am_i = PLAYER1;
	else
		game->who_am_i = PLAYER2;
	
	if ( CHATROOM(game->connection)->gamehost[0] != 0)
		{
			sqirc_send(game->connection,
								 "PRIVMSG %s :\001GAMEDONE %s %i %i %i -\001\r\n",
								 CHATROOM(game->connection)->gamehost,
								 game->opponent,
								 game->p1_score,
								 game->p2_score,
								 game->who_am_i);   /* this is the 'lowball'-exchanged value */
		}
	
	/* i'm lazy, use the original messages, these will do the job */
	game_gameover_get_captions(game, &captions);
	
	/* switch back players to restore real settings */
	if (game->who_am_i == PLAYER2)
		game->who_am_i = PLAYER1;
	else
		game->who_am_i = PLAYER2;
	
	game_gameover_dialog(game, captions.message, captions.ok, captions.abort);
	return PLUGIN_SUCCESS;
}

SquaroidPlugin plugin_lowball =
{
	"Lowball",                              /* name */
	0,                                      /* flags */
	NULL,                                   /* network commands */
	lowball_onload,                         /* on load */
	lowball_onunload,                       /* on unload */
	NULL,                                   /* on invite */
	NULL,                                   /* on invite send */
	lowball_ongamestart,                    /* on GameStart */
	NULL,                                   /* on move */
	NULL,                                   /* on square */
	lowball_ongameover,                     /* on game over */
	NULL,                                   /* on cleanup */
};

#if COMPILE_DL
SquaroidPlugin *get_module()
{
	return &plugin_lowball;
}
#endif
