#ifndef SQ_HAVE_CHATROOM
#define SQ_HAVE_CHATROOM

#include "types.h"

Chatroom *chatroom_create(struct connection *);
void chatroom_destroy(Chatroom *chatroom);
void chatroom_join(Chatroom *, const char *);
void chatroom_create_debugwindow();
void chatroom_say(GtkWidget *w, gpointer data);
void chatroom_chatmessage(Chatroom *, char *, ...);
void chatroom_debugmessage(char *, ...);
void chatroom_player_add(Chatroom *, const char *, guint);
gint chatroom_player_inlist(Chatroom *, const char *name);
void chatroom_player_remove(Chatroom *, char *, char *);
void chatroom_player_update(Chatroom *, Player *);
void chatroom_player_mark_invalid(Chatroom *, int row);
void chatroom_player_clearlist(Chatroom *);
void chatroom_freeze(Chatroom *);
void chatroom_thaw(Chatroom *);

void PrintText(GtkWidget *, char *message);
void PrintTextDebug (char *message);

#endif
