#ifndef SQ_HAVE_GAME
#define SQ_HAVE_GAME

#include <gtk/gtkwidget.h>
#include <gdk/gdk.h>


struct gameover_captions
{
	char message[BUFSIZE];
	char ok[BUFSIZE];
	char abort[BUFSIZE];
};

/* activate a toggle button */
#define ACTIVATE(_but) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(_but), TRUE)  
/* get the RadioButton group of a button _but */
#define RGROUP(_but) ((_but)?gtk_radio_button_group(GTK_RADIO_BUTTON(_but)):0)


/* game_invite.c   Invitation Stuff */
void game_play_request(Game *);
void game_play_request_abort(Game *);


/* game_network.c      GAME_NETWORK */

/* game.c              Common Stuff */
void *game_alloc(Game *, size_t);
void game_free(Game *, void *);

Game *game_create(struct connection *);
void game_start_playing(Game *, enum gamemode);
void game_chatmessage(Game *, char *, ...);
void game_cleanup(Game *);
void game_cleanup_all(struct connection *);
void game_notify_quit(Game *);
void game_reset_values(Game *);

/* game_observe.c   GAME_OBSERVE  */
void game_observe_request(Game *);
char *game_encode_board_data(Game *);
void game_decode_board_data(Game *, char *move_data);

/* game_canvas.c    Canvas Drawing */
void game_canvas_update_last_stone(Game *);
void game_paint_stone(Game *, struct movedata move, int mode);
void game_paint_square(Game *, struct point p[], int mode);
void game_paint_old_lines(Game *);
void game_paint_old_stones(Game *);
void cb_canvas_realize(GtkWidget *w);
gint cb_canvas_expose(GtkWidget *w, GdkEventExpose *e);
gboolean cb_canvas_button_press(GtkWidget *, GdkEventButton *, gpointer);
gboolean cb_canvas_button_release(GtkWidget *, GdkEventButton *, gpointer);
void board_draw_background(Game *);
void game_canvas_put_stone(Game *, gint xf, gint yf);

/* game_squares.c   Algorithms to find the squares */
void squares_find(Game *);
void game_find_squares(Game *);
void game_check_for_squares(Game *,struct point points[], int n_points);
int  game_is_square(Game *, struct point, struct point,
										struct point, struct point);
void game_sort_points(struct point points[],int n_points);
/* ==================== */

void game_next_move(Game *);
void game_add_to_score(Game *, gint score);
void game_is_over(Game *);
void game_gameover_dialog(Game *,	const char *,	const char *,	const char *);
void game_get_names(Game *, char *, char *);
void game_gameover_get_captions(Game *, struct gameover_captions *);
void board_draw_background(Game *);

void cb_gameover_again(GtkWidget *e, gpointer);
void cb_gameover_giveup(GtkWidget *e, gpointer);

/* game_common.c */
void cb_game_notify_quit(GtkWidget *, gpointer);
void cb_chat(GtkWidget *, gpointer);
void cb_notebook_switch(GtkWidget *, GtkNotebookPage *, guint);

/* game_network.c */

void cb_leave(GtkWidget *, gpointer);

#endif

