#include "squaroid.h"
#include <stdarg.h>

#define SEND_MAX 256             /* max # of bytes to send out at once */
#define QUEUE_TIMEOUT 2500       /* msec's to wait before sending again */

/* ######################################################################
	 net_send_ctcp_version:
	 sends an version request out to the player named nickname
	 
	 this is to make sure the other side has a version with at least
	 the same capabilities
*/
void net_send_ctcp_version(struct connection *connection,
													 const char *nickname)
{
	sqirc_send(connection, "PRIVMSG %s :\001VERSION\001\r\n", nickname);
}

void net_send_privmsg(struct connection *connection,
											const char *nickname,
											const char *message)
{
	sqirc_send(connection, "PRIVMSG %s :%s\r\n", nickname, message);
}
